
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1176;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1437;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7674;

void main()
{
    int _1166 = gl_InstanceIndex + gl_DrawIDARB;
    int _1167 = readFirstInvocationARB(_1166);
    uint _3103 = uint(gl_VertexIndex);
    uint _3106 = _3103 + _1176.g_cbMainArray._aMain[_1167]._Indices._uiPositionOffset;
    uint _3126 = _3103 + _1176.g_cbMainArray._aMain[_1167]._Indices._uiNormalOffset;
    int _3155 = g_rbTBNs_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3126]._iNormal & 1023;
    int _3158 = (g_rbTBNs_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3126]._iNormal >> 10) & 1023;
    int _3161 = (g_rbTBNs_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3126]._iNormal >> 20) & 1023;
    int _7661;
    if (_3155 > 512)
    {
        _7661 = _3155 | (-1024);
    }
    else
    {
        _7661 = _3155;
    }
    int _7663;
    if (_3158 > 512)
    {
        _7663 = _3158 | (-1024);
    }
    else
    {
        _7663 = _3158;
    }
    int _7665;
    if (_3161 > 512)
    {
        _7665 = _3161 | (-1024);
    }
    else
    {
        _7665 = _3161;
    }
    float _3204 = float(_7661);
    float _3207 = float(_7663);
    float _3210 = float(_7665);
    vec3 _3211 = vec3(_3204, _3207, _3210);
    vec3 _3214 = _3211 * vec3(0.001956947147846221923828125);
    vec4 _3337 = vec4(g_rbVertices_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiPositionsBufferIndex].g_rbVertices[_3106].x, g_rbVertices_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiPositionsBufferIndex].g_rbVertices[_3106].y, g_rbVertices_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiPositionsBufferIndex].g_rbVertices[_3106].z, 1.0);
    vec4 _3338 = g_rbObjects_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiObjectIndex].g_rbObjects[0]._mModel * _3337;
    vec3 _3339 = _3338.xyz;
    mat3 _3496 = mat3(g_rbObjects_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3499 = _3496 * _3214;
    vec3 _7606 = _7674;
    _7606.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(1.0, 1.5)) + vec2(-0.0350000001490116119384765625, -2.150000095367431640625), 0.0).x;
    vec3 _3715 = vec3(g_rbMaterialInstances_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3718 = mod(_3715, vec3(2.0));
    vec3 _3722 = _7606 * _3718;
    vec3 _3726 = clamp(_3722, vec3(0.0), vec3(1.0));
    vec3 _7615 = _7674;
    _7615.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(2.0)) + vec2(-0.1500000059604644775390625, -2.230000019073486328125), 0.0).y;
    vec3 _3756 = _3715 * vec3(0.100000001490116119384765625);
    vec3 _3759 = floor(_3756);
    vec3 _3763 = mod(_3759, vec3(2.0));
    vec3 _3767 = _7615 * _3763;
    vec3 _3771 = clamp(_3767, vec3(0.0), vec3(1.0));
    vec3 _3775 = vec3(1.0) - _3726;
    vec3 _3778 = vec3(1.0) - _3771;
    vec3 _3779 = _3775 * _3778;
    vec3 _3781 = vec3(1.0) - _3779;
    vec3 _3785 = clamp(_3781, vec3(0.0), vec3(1.0));
    vec3 _7624 = _7674;
    _7624.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(2.5, 1.5)) + vec2(-1.22449004650115966796875, -1.5), 0.0).z;
    vec3 _3815 = _3715 * vec3(0.00999999977648258209228515625);
    vec3 _3818 = floor(_3815);
    vec3 _3822 = mod(_3818, vec3(2.0));
    vec3 _3826 = _7624 * _3822;
    vec3 _3830 = clamp(_3826, vec3(0.0), vec3(1.0));
    vec3 _3834 = vec3(1.0) - _3785;
    vec3 _3837 = vec3(1.0) - _3830;
    vec3 _3838 = _3834 * _3837;
    vec3 _3840 = vec3(1.0) - _3838;
    vec3 _3844 = clamp(_3840, vec3(0.0), vec3(1.0));
    float _3846 = _3844.y;
    float _3851 = _3846 - 0.949999988079071044921875;
    float _3856 = _3851 * 19.9959964752197265625;
    float _3857 = clamp(_3856, 0.0, 1.0);
    float _3858 = mix(0.0, 1.0, _3857);
    float _3866 = _3846 - 0.88999998569488525390625;
    float _3871 = _3866 * 99.90019989013671875;
    float _3872 = clamp(_3871, 0.0, 1.0);
    float _3873 = mix(0.0, 1.0, _3872);
    vec3 _3878 = vec3(_3873);
    vec3 _3879 = mix(vec3(0.0), vec3(-0.0058050001971423625946044921875), _3878);
    vec3 _3884 = vec3(_3858);
    vec3 _3885 = mix(_3879, vec3(-0.011610000394284725189208984375), _3884);
    vec3 _3891 = _3885 * _3499;
    vec3 _3899 = vec3(g_rbMaterialInstances_Buffer[_1176.g_cbMainArray._aMain[_1167]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3900 = mix(vec3(0.0), _3891, _3899);
    vec3 _3923 = _3339 + _3900;
    float _3988 = _3923.x;
    float _3989 = _3923.y;
    float _3990 = _3923.z;
    vec4 _3991 = vec4(_3988, _3989, _3990, 1.0);
    vec4 _3992 = _1437.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mView * _3991;
    vec4 _4008 = _1437.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mViewJitteredProj * _3991;
    vec4 _7671;
    if (_1437.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4023 = _4008.w;
        vec4 _7672;
        if ((_4008.z / _4023) > 1.0)
        {
            vec4 _7673;
            if (_3992.z > _1437.g_cbPass._fNearPlane)
            {
                vec4 _7637 = _4008;
                _7637.z = _4023;
                _7673 = _7637;
            }
            else
            {
                _7673 = _4008;
            }
            _7672 = _7673;
        }
        else
        {
            _7672 = _4008;
        }
        _7671 = _7672;
    }
    else
    {
        _7671 = _4008;
    }
    interp_instanceID = float(_1166) + 0.5;
    float _2989 = _3992.x;
    float _2990 = _3992.y;
    float _2991 = _3992.z;
    vec4 _2992 = vec4(_2989, _2990, _2991, 1.0);
    float _2993 = dot(_1437.g_cbPass._vfVsClippingPlane[0], _2992);
    float _2994 = -_2993;
    gl_ClipDistance[0] = _2994;
    gl_Position = _7671;
}

